#!/bin/bash

# Make results directory as needed
results_path="results/q1"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/blackscholes.simmedium.txt"

if [ -f "$trace_path" ]; then
  echo "Trace file found."
else
  echo "Trace file not found. Please add '$trace_path'."
fi

# Tests for SSCI increasing cache line size
./dsm 1048576 4 32 16 1 $trace_path > $results_path/ssci_32.txt
./dsm 1048576 4 64 16 1 $trace_path > $results_path/ssci_64.txt
./dsm 1048576 4 128 16 1 $trace_path > $results_path/ssci_128.txt
./dsm 1048576 4 256 16 1 $trace_path > $results_path/ssci_256.txt
./dsm 1048576 4 512 16 1 $trace_path > $results_path/ssci_512.txt
