#!/bin/bash

# Make results directory as needed
results_path="results/q2"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/blackscholes.simmedium.txt"

if [ -f "$trace_path" ]; then
  echo "Trace file found."
else
  echo "Trace file found. Please '$trace_path'."
  exit
fi

# Increasing Associativity Tests for SSCI Small Cache
./dsm 131072 1 64 16 1 $trace_path > $results_path/ssci_small_1.txt
./dsm 131072 2 64 16 1 $trace_path > $results_path/ssci_small_2.txt
./dsm 131072 4 64 16 1 $trace_path > $results_path/ssci_small_4.txt
./dsm 131072 8 64 16 1 $trace_path > $results_path/ssci_small_8.txt

# Increasing Associtiavity Tests for SSCI Large Cache
./dsm 1048576 1 64 16 1 $trace_path > $results_path/ssci_large_1.txt
./dsm 1048576 2 64 16 1 $trace_path > $results_path/ssci_large_2.txt
./dsm 1048576 4 64 16 1 $trace_path > $results_path/ssci_large_4.txt
./dsm 1048576 8 64 16 1 $trace_path > $results_path/ssci_large_8.txt
