#!/bin/bash

# Make results directory as needed 
results_path="results/q3"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/bodytrack.test.txt"

if [ -f "$trace_path" ]; then
  echo "Trace file found."
else
  echo "Trace file found. Please add '$trace_path'."
  exit
fi

# Tests for SSCI Increasing Cache Size
./dsm 131072 4 64 16 1 $trace_path > $results_path/ssci_128.txt
./dsm 262144 4 64 16 1 $trace_path > $results_path/ssci_256.txt
./dsm 524288 4 64 16 1 $trace_path > $results_path/ssci_512.txt
./dsm 1048576 4 64 16 1 $trace_path > $results_path/ssci_1024.txt
./dsm 2097152 4 64 16 1 $trace_path > $results_path/ssci_2048.txt
